package com.huimv.eartag2.manage.service;

import com.huimv.eartag2.common.utils.Result;

import java.text.ParseException;

public interface IEartagService {
    //
    Result getEartagRegisterByEarmark(String earmark);

    //根据耳标号读取今天所有流水
    Result listEartagFlowByEarmarkAndToday(String earmark) throws ParseException;

    Result listEartagFlowByDeviceCodeAndEarmarkAndToday(String earmark, String deviceCode) throws ParseException;

    //显示耳标在线统计
    Result listEartagOnlineCountByEarmarkAndDate(String earmark, Integer pastDays) throws ParseException;

    //显示耳标在线统计
    Result listEartagOnlineStatusByEarmarkAndDate(String earmark, Integer pastDays) throws ParseException;

    //带分页查询耳标流水
    Result listEartagFlowByEarmarkAndTodayInPager(String earmark, Integer pageNo, Integer pageSize);

    //带分页查询耳标流水
    Result listEartagFlowByDeviceCodeAndEarmarkAndTodayInPager(String earmark, String deviceCode, Integer pageNo, Integer pageSize);

    //带分页查询耳标流水
    Result listEartagFlowByDeviceCodeAndEarmarkAndDateInPager(String earmark, String deviceCode, String addDate, Integer pageNo, Integer pageSize);

    //前N天的耳标在线状态
    Result listEartagOnlineAllStatus(String farmId, Integer days) throws ParseException;

    //展示在线耳标列表
    Result listOnlineEartagCount(String farmId, String addDate, Integer pageNo, Integer pageSize, Integer showMode) throws ParseException;

    //获取该耳边前N天历史记录
//    Result getEartagOnlineCountByEarmark(String earmark, Integer days) throws ParseException;

    //通过耳标号和日期获取耳标关联设备信息
    Result getEartagDeviceByEarmarkAndAddDate(String earmark, String addDate);
}
