package com.huimv.eartag2.manage.service.impl;

import com.huimv.eartag2.common.dao.entity.EartarFarmAllStatusEntity;
import com.huimv.eartag2.common.utils.BizConst;
import com.huimv.eartag2.manage.service.ICacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
public class CacheServiceImpl implements ICacheService {
    @Autowired
    private RedisTemplate redisTemplate;

    @Override
    public Map getFarmAllStatusByFarmId(String farmId) {
        String hashKey = BizConst.FARM_ALL_STATUS_PREFIX+farmId;
        return redisTemplate.opsForHash().entries(hashKey);
    }

    @Override
    public int getDeviceOnlineTotal(String farmId, String todayDateText) {
        String setKey = BizConst.SET_FARM_DEVICE_ONLINE_PREFIX+farmId+"_"+todayDateText;
        Set<String> resultSet = redisTemplate.opsForSet().members(setKey);
        return resultSet.size();
    }

    @Override
    public int getEartagOnlineTotal(String farmId, String todayDateText) {
        String setKey = BizConst.SET_FARM_EARMARK_ONLINE_PREFIX+farmId+"_"+todayDateText;
        Set<String> resultSet = redisTemplate.opsForSet().members(setKey);
        return resultSet.size();
    }

    @Override
    public void putFarmAllStatusCache(String farmId, EartarFarmAllStatusEntity farmAllStatusEntity) {
        Map allStatusMap = new HashMap();
//        allStatusMap.put("id",farmAllStatusEntity.getId());
        allStatusMap.put("deviceTotal",farmAllStatusEntity.getDeviceTotal());
        allStatusMap.put("deviceOnline",farmAllStatusEntity.getDeviceOnline());
        allStatusMap.put("deviceOffline",farmAllStatusEntity.getDeviceOffline());
        allStatusMap.put("deviceRate",farmAllStatusEntity.getDeviceRate());
        allStatusMap.put("deviceCancel",farmAllStatusEntity.getDeviceCancel());
        allStatusMap.put("eartagTotal",farmAllStatusEntity.getEartagTotal());
        allStatusMap.put("eartagOnline",farmAllStatusEntity.getEartagOnline());
        allStatusMap.put("farmId",farmId);
//        allStatusMap.put("updateTime",duObj.formatDateTime(duObj.getTodayText()));
//        allStatusMap.put("createDate",duObj.getTodayDate());
        allStatusMap.put("updateTime",farmAllStatusEntity.getUpdateTime());
        allStatusMap.put("createDate",farmAllStatusEntity.getCreateDate());
        redisTemplate.opsForHash().putAll(BizConst.FARM_ALL_STATUS_PREFIX+farmId, allStatusMap);
    }
}
